// naumann@stce.rwth-aachen.de

#include <iostream> 
#include <cassert> 
#include <cmath> 
#include <limits> 

using T=double;

T estimate(T x1, T y1, T x2, T y2) {
  T d=(pow(x1,2)+pow(x2,2)); 
  assert(d!=0); 
  return (x1*y1+x2*y2)/d; 
}

int main() {
  using namespace std;
  T x1=0,x2=0,y1=0,y2=0;
  cout << "x1="; cin >> x1; cout << "y1="; cin >> y1;
  cout << "x2="; cin >> x2; cout << "y2="; cin >> y2;
  T aux1=x1*y1+x2*y2, aux2=pow(x1,2)+pow(x2,2), aux3=pow(aux2,2);
  cout << "dp/dx1=" <<  y1/aux2-2*x1*aux1/aux3 << endl;
  cout << "dp/dx2=" <<  y2/aux2-2*x2*aux1/aux3 << endl;
  cout << "dp/dx1=" <<  x1/aux2 << endl;
  cout << "dp/dx1=" <<  x2/aux2 << endl;
  return 0;
}
